Query
The query call sends a query expression by specifying the object to query, the fields to retrieve from that object, and any filters to determine whether a given object should be queried.
You can use Zuora Object Query Language(ZOQL) to construct those queries, passing them through the queryString.
Once the call is made, the API executes the query against the specified object and returns a query response object to your application. Your application can then iterate through rows in the query response to retrieve information.
Limitations
This call has the following limitations:
- All ZOQL limitations apply.
- All ZOQL keywords must be in lower case.
- The number of records returned is limited to 2000 records.
- The Invoice Settlement feature is not supported. This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement.
- The Orders feature is not supported, which means that the objects listed in Orders Object Model are not supported.
- The Active Rating feature is not supported.
- The default WSDL version for Actions is 79. To query objects or fields according to a different WSDL version, set the
X-Zuora-WSDL-Versionheader. To find out in which WSDL version a particular object or field was introduced, see Zuora SOAP API Version History. - Fields with NULL values are not returned in the response.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
The minor API version.
For a list of available minor versions, see API upgrades.
Query parameters
Specifies whether the call fails if the request body contains unknown fields.
With rejectUnknownFields set to true, Zuora returns a 400 response if
the request body contains unknown fields. The body of the 400 response is:
{
"message": "Error - unrecognised fields"
}
By default, Zuora ignores unknown fields in the request body.
Request
ZOQL expression that specifies the object to query, the fields to retrieve, and any filters.
Note: When querying one time charges from ProductRatePlanCharge, you need to specify the ChargeType value as One-Time rather than OneTime.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
Indicates whether the returned records contain all the query results.
- If the
queryLocatorfield is returned, this field is set tofalse. - If no
queryLocatorfield is returned, this field is set totrue.
A marker passed to QueryMore to get the next set of results. For more information, see QueryMore.